//______________________________________________________________________________

//                   Pklad pouit knihovny Tpci1054u.dll

//                           (Visual Studio 2010)

//                Copyright (c) 1998-2014 TEDIA spol. s r.o.
//______________________________________________________________________________


// Program demonstruje voln jednotlivch funkc knihovny Tpci1054u pro
// komunikaci s modulem MicroUnit pes kartu PCI-1054U.
// Pro pouit knihovny je nutn znalost modulu MicroUnit v rozsahu jeho
// Uivatelsk pruky (implementace periferi u danho modulu).
// Knihovnu nen nutno samostatn instalovat, sta ji v rmci instalace
// aplikanho software pouze pekoprovat do msta, kam bude mt aplikan
// program nastavenu cestu.

//______________________________________________________________________________


#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <locale.h>


//______________________________________________________________ FUNKN PROTOTYPY

// funkce knihovny

typedef uint32_t (__stdcall *t_TPCI1054U_Version)(uint32_t*);
typedef uint32_t (__stdcall *t_TPCI1054U_Init)(uint32_t*, uint32_t*);
typedef uint32_t (__stdcall *t_TPCI1054U_SetConfig)(uint32_t, uint32_t, uint32_t, uint32_t);
typedef uint32_t (__stdcall *t_TPCI1054U_GetConfig)(uint32_t, uint32_t*, uint32_t*, uint32_t*);
typedef uint32_t (__stdcall *t_TPCI1054U_Send)(uint32_t, uint32_t*, uint32_t*, uint32_t*, uint32_t*);
typedef uint32_t (__stdcall *t_TPCI1054U_Send1)(uint32_t, uint32_t*, uint32_t*, uint32_t);
typedef uint32_t (__stdcall *t_TPCI1054U_Done)(uint32_t*);
typedef uint32_t (__stdcall *t_TPCI1054U_Error)(uint32_t, uint32_t*);

t_TPCI1054U_Version   TPCI1054U_Version;
t_TPCI1054U_Init      TPCI1054U_Init;
t_TPCI1054U_SetConfig TPCI1054U_SetConfig;
t_TPCI1054U_GetConfig TPCI1054U_GetConfig;
t_TPCI1054U_Send      TPCI1054U_Send;
t_TPCI1054U_Send1     TPCI1054U_Send1;
t_TPCI1054U_Done      TPCI1054U_Done;
t_TPCI1054U_Error     TPCI1054U_Error;



// pomocn funkce

uint32_t PrevodAIBusDWord(uint32_t D1, uint32_t D2, uint32_t D3, uint32_t D4);
double PrevodAIBusReal(uint32_t D1, uint32_t D2, uint32_t D3, uint32_t D4);
uint8_t* PrevodTextError(uint32_t *B);


//______________________________________________________________ GLOBLN PROMNN

uint32_t Par[16];
uint32_t BuffT[1024];
uint32_t BuffR[1024];
uint32_t ErrText[100];

HINSTANCE hinstLib;

uint32_t HNDL;

uint32_t AdresaMU    = 1;                // adresa pipojenho modulu MicroUnit k MU-1052
uint32_t BaudMU      = 9600;             // rychlost pipojenho modulu MicroUnit k MU-1052
uint32_t TimeoutMU   = 100;              // [ms] timeout ekn na odpov modulu MicroUnit
uint32_t OpakovaniMU = 2;                // poet opakovanch dotaz pi chyb komunikace

uint32_t EUART       = 0;                // slo adie EUART



//______________________________________________________________ main

int _tmain(int argc, _TCHAR* argv[])
{
  uint32_t i;
  uint32_t result;
  BOOL fFreeResult;



// nastaven znakov sady
  char* localcharset = setlocale(LC_ALL, "");
  if (localcharset == NULL)
  {
    printf("Locale not set\n");
  }



// nataen knihovny do pamti

  hinstLib = LoadLibrary(TEXT("Tpci1054u.dll"));
  if (hinstLib == NULL)
  {
    printf("Chyba volani funkce LoadLibrary\n");
    fFreeResult = FreeLibrary(hinstLib);
    return 1;
  }



// zjitn adres funkc v knihovn

  TPCI1054U_Version = (t_TPCI1054U_Version) GetProcAddress(hinstLib, "TPCI1054U_Version");
  TPCI1054U_Init = (t_TPCI1054U_Init) GetProcAddress(hinstLib, "TPCI1054U_Init");
  TPCI1054U_SetConfig = (t_TPCI1054U_SetConfig) GetProcAddress(hinstLib, "TPCI1054U_SetConfig");
  TPCI1054U_GetConfig = (t_TPCI1054U_GetConfig) GetProcAddress(hinstLib, "TPCI1054U_GetConfig");
  TPCI1054U_Send = (t_TPCI1054U_Send) GetProcAddress(hinstLib, "TPCI1054U_Send");
  TPCI1054U_Send1 = (t_TPCI1054U_Send1) GetProcAddress(hinstLib, "TPCI1054U_Send1");
  TPCI1054U_Done = (t_TPCI1054U_Done) GetProcAddress(hinstLib, "TPCI1054U_Done");
  TPCI1054U_Error = (t_TPCI1054U_Error) GetProcAddress(hinstLib, "TPCI1054U_Error");



// naten verze knihovny ------------------------------------------------------

  uint32_t VerzeDLL;

  result = TPCI1054U_Version(&VerzeDLL);

  // vyhodnocen chyby voln funkce TPCI1054U_Version
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Version: %lu - %s\n", (unsigned long)result, PrevodTextError(ErrText));
    return 0;
  }

  // vpis verze
  printf("Verze knihovny Tpci1054u.dll: %d.%02d\n",  (VerzeDLL/100), (VerzeDLL%100));



// inicializace knihovny -------------------------------------------------------

  for (i=0;i<16;i++) Par[i] = 0;
  Par[0] = 0;                  // 0=automatick detekce karty (prvn nalezen)
  Par[1] = 0;                  // BUS (nepouito)
  Par[2] = 0;                  // SLOT (nepouito)
  Par[3] = EUART;              // adi EUART
  result = TPCI1054U_Init(&HNDL, Par);

  // vyhodnocen chyby voln funkce TPCI1054U_Init
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Init: %lu - %s\n", (unsigned long)result, PrevodTextError(ErrText));
    return 0;
  }



// nastaven komunikanch parametr linky RS-485 ------------------------------

  result = TPCI1054U_SetConfig(HNDL, BaudMU, TimeoutMU, OpakovaniMU);

  // vyhodnocen chyby voln funkce TPCI1054U_SetConfig
  if (result!=0)
  {

    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_SetConfig: %lu - %s\n", (unsigned long)result, PrevodTextError(ErrText));
    return 0;
  }



// naten komunikanch parametr linky RS-485 --------------------------------

  result = TPCI1054U_GetConfig(HNDL, &BaudMU, &TimeoutMU, &OpakovaniMU);

  // vyhodnocen chyby voln funkce TPCI1054U_GetConfig
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_GetConfig: %lu - %s\n", (unsigned long)result, PrevodTextError(ErrText));
    return 0;
  }

  // vpis komunikanch parametr
  printf("Baud: %lu  Timeout: %lu  Opakovani: %lu\n", (unsigned long) BaudMU, (unsigned long) TimeoutMU, (unsigned long) OpakovaniMU);



// zjitn typu a verze vzdlenho modulu -------------------------------------

  uint32_t StatusR;
  uint32_t StatusP;

  uint8_t TypMU[9];
  uint8_t VerzeMU[5];

  // zprva 1 - dotaz AIBus-2 protokolu (prv tyi znaky typovho oznaen modulu)
  BuffT[0] = AdresaMU;	        // adresa modulu MicroUnit
  BuffT[1] = 200;	        // funkce modulu MicroUnit
  BuffT[2] = 0;			// periferie modulu MicroUnit
  BuffT[3] = 0;			// pomocn povel
  BuffT[4] = 0;			// data D0
  BuffT[5] = 0;			// data D1
  BuffT[6] = 0;			// data D2
  BuffT[7] = 0;			// data D3
  // zprva 2 - dotaz AIBus-2 protokolu (druh tyi znaky typovho oznaen modulu)
  BuffT[8] = AdresaMU;        // adresa modulu MicroUnit
  BuffT[9] = 200;	        // funkce modulu MicroUnit
  BuffT[10] = 1;		// periferie modulu MicroUnit
  BuffT[11] = 0;		// pomocn povel
  BuffT[12] = 0;		// data D0
  BuffT[13] = 0;		// data D1
  BuffT[14] = 0;		// data D2
  BuffT[15] = 0;		// data D3
  // zprva 3 - dotaz AIBus-2 protokolu (tyi znaky verze modulu)
  BuffT[16] = AdresaMU;	// adresa modulu MicroUnit
  BuffT[17] = 200;	        // funkce modulu MicroUnit
  BuffT[18] = 2;		// periferie modulu MicroUnit
  BuffT[19] = 0;		// pomocn povel
  BuffT[20] = 0;		// data D0
  BuffT[21] = 0;		// data D1
  BuffT[22] = 0;		// data D2
  BuffT[23] = 0;		// data D3
  result = TPCI1054U_Send1(HNDL, BuffT, BuffR, 3);

  // vyhodnocen chyby voln funkce TPCI1054U_Send1
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Send1: %lu - %s\n", (unsigned long) result, PrevodTextError(ErrText));
    return 0;
  }

  // vyhodnocen chyby komunikace jednotlivch zprv
  StatusP = BuffR[0+4];         // zprva 1
  if (StatusP!=0)
  {
    TPCI1054U_Error(StatusP, ErrText);
    printf("Status komunikace: %lu - %s\n", (unsigned long) StatusP, PrevodTextError(ErrText));
    return 0;
  }
  StatusP = BuffR[8+4];         // zprva 2
  if (StatusP!=0)
  {
    TPCI1054U_Error(StatusP, ErrText);
    printf("Status komunikace: %lu - %s\n", (unsigned long) StatusP, PrevodTextError(ErrText));
    return 0;
  }
  StatusP = BuffR[16+4];        // zprva 3
  if (StatusP!=0)
  {
    TPCI1054U_Error(StatusP, ErrText);
    printf("Status komunikace: %lu - %s\n", (unsigned long) StatusP, PrevodTextError(ErrText));
    return 0;
  }
  StatusR = BuffR[16+5];

  // pijat data typu ASCII
  TypMU[0]   = (uint8_t)BuffR[0+0];
  TypMU[1]   = (uint8_t)BuffR[0+1];
  TypMU[2]   = (uint8_t)BuffR[0+2];
  TypMU[3]   = (uint8_t)BuffR[0+3];
  TypMU[4]   = (uint8_t)BuffR[8+0];
  TypMU[5]   = (uint8_t)BuffR[8+1];
  TypMU[6]   = (uint8_t)BuffR[8+2];
  TypMU[7]   = (uint8_t)BuffR[8+3];
  TypMU[8]   = 0;
  VerzeMU[0] = (uint8_t)BuffR[16+0];
  VerzeMU[1] = (uint8_t)BuffR[16+1];
  VerzeMU[2] = (uint8_t)BuffR[16+2];
  VerzeMU[3] = (uint8_t)BuffR[16+3];
  VerzeMU[4] = 0;

  // vpis pijatch dat
  printf("StatusP: %lu  StatusR: %lu  Typ modulu: %s  Verze modulu: %s\n", (unsigned long) StatusP, (unsigned long) StatusR, TypMU, VerzeMU);



// ten analogovho vstupu AIN ------------------------------------------------

  double AIN;

  // dotaz AIBus-2 protokolu (AIN0)
  BuffT[0] = AdresaMU;	      // adresa modulu MicroUnit
  BuffT[1] = 0;		      // funkce modulu MicroUnit (0=ten)
  BuffT[2] = 0;		      // periferie modulu MicroUnit (0=AIN0)
  BuffT[3] = 0;		      // pomocn povel
  BuffT[4] = 0;		      // data D0
  BuffT[5] = 0;		      // data D1
  BuffT[6] = 0;		      // data D2
  BuffT[7] = 0;		      // data D3
  result = TPCI1054U_Send(HNDL, BuffT, BuffR, &StatusR, &StatusP);

  // vyhodnocen chyby voln funkce TPCI1054U_Send
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Send: %lu - %s\n", (unsigned long) result, PrevodTextError(ErrText));
    return 0;
  }

  // vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  if (StatusP!=0)
  {
    TPCI1054U_Error(StatusP, ErrText);
    printf("Status komunikace: %lu - %s\n", (unsigned long) StatusP, PrevodTextError(ErrText));
    return 0;
  }

  // pevod pijatch dat
  AIN = PrevodAIBusReal(BuffR[0], BuffR[1], BuffR[2], BuffR[3]);

  // vpis pijatch dat
  printf("StatusP: %lu  StatusR: %lu  Analogovy vstup AIN0: %4.1f \n", (unsigned long) StatusP, (unsigned long) StatusR, AIN);



// ten tae CNT ------------------------------------------------------------

  uint32_t CNT;

  // dotaz AIBus-2 protokolu (AIN16)
  BuffT[0] = AdresaMU;	      // adresa modulu MicroUnit
  BuffT[1] = 0;		      // funkce modulu MicroUnit (0=ten)
  BuffT[2] = 80;	      // periferie modulu MicroUnit (80=CNT0)
  BuffT[3] = 0;		      // pomocn povel
  BuffT[4] = 0;		      // data D0
  BuffT[5] = 0;		      // data D1
  BuffT[6] = 0;		      // data D2
  BuffT[7] = 0;		      // data D3
  result = TPCI1054U_Send(HNDL, BuffT, BuffR, &StatusR, &StatusP);

  // vyhodnocen chyby voln funkce TPCI1054U_Send
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Send: %lu - %s\n", (unsigned long) result, PrevodTextError(ErrText));
    return 0;
  }

  // vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  if (StatusP!=0)
  {
    TPCI1054U_Error(StatusP, ErrText);
    printf("Status komunikace: %lu - %s\n", (unsigned long) StatusP, PrevodTextError(ErrText));
    return 0;
  }

  // pevod pijatch dat
  CNT = PrevodAIBusDWord(BuffR[0], BuffR[1], BuffR[2], BuffR[3]);

  // vpis pijatch dat
  printf("StatusP: %lu  StatusR: %lu  Citac CNT0: %lu\n", (unsigned long) StatusP, (unsigned long) StatusR, (unsigned long) CNT);



  // ten digitlnch vstup DIN0 a DIN31 --------------------------------------

  // dotaz AIBus-2 protokolu (DIN)
  BuffT[0] = AdresaMU;	      // adresa modulu MicroUnit
  BuffT[1] = 0;		      // funkce modulu MicroUnit (0=ten)
  BuffT[2] = 64;	      // periferie modulu MicroUnit (64=DIN)
  BuffT[3] = 0;		      // pomocn povel
  BuffT[4] = 0;		      // data D0
  BuffT[5] = 0;		      // data D1
  BuffT[6] = 0;		      // data D2
  BuffT[7] = 0;		      // data D3
  result = TPCI1054U_Send(HNDL, BuffT, BuffR, &StatusR, &StatusP);

  // vyhodnocen chyby voln funkce TPCI1054U_Send
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Send: %lu - %s\n", (unsigned long) result, PrevodTextError(ErrText));
    return 0;
  }

  // vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  if (StatusP!=0)
  {
    TPCI1054U_Error(StatusP, ErrText);
    printf("Status komunikace: %lu - %s\n", (unsigned long) StatusP, PrevodTextError(ErrText));
    return 0;
  }

  // vpis pijatch dat
  printf("StatusP: %lu  StatusR: %lu  Digitalni vstupy DIN0-DIN31: %02x %02x %02x %02x\n",
         (unsigned long) StatusP,
         (unsigned long) StatusR,
         (unsigned char)BuffR[0],
         (unsigned char)BuffR[1],
         (unsigned char)BuffR[2],
         (unsigned char)BuffR[3]);



  // zpis digitlnch vstup DOUT0 a DOUT31 -----------------------------------

  // dotaz AIBus-2 protokolu (sepnut DOUT1 a DOUT3, ostatn DOUT vypnout)
  BuffT[0] = AdresaMU;	      // adresa modulu MicroUnit
  BuffT[1] = 1;		      // funkce modulu MicroUnit (1=zpis)
  BuffT[2] = 64;	      // periferie modulu MicroUnit (64=DOUT)
  BuffT[3] = 0;		      // pomocn povel
  BuffT[4] = 0x0A;	      // data D0 (DOUT0-7)
  BuffT[5] = 0;		      // data D1 (DOUT8-15)
  BuffT[6] = 0;		      // data D2 (DOUT16-23)
  BuffT[7] = 0;		      // data D3 (DOUT24-31)
  result = TPCI1054U_Send(HNDL, BuffT, BuffR, &StatusR, &StatusP);

  // vyhodnocen chyby voln funkce TPCI1054U_Send
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Send: %lu - %s\n", (unsigned long) result, PrevodTextError(ErrText));
    return 0;
  }

  // vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  if (StatusP!=0)
  {
    TPCI1054U_Error(StatusP, ErrText);
    printf("Status komunikace: %lu - %s\n", (unsigned long) StatusP, PrevodTextError(ErrText));
    return 0;
  }

  // vpis pijatch dat
  printf("StatusP: %lu  StatusR: %lu  Digitalni vystupy DOUT0-DOUT31: %02x %02x %02x %02x\n",
         (unsigned long) StatusP,
         (unsigned long) StatusR,
         (unsigned char)BuffR[0],
         (unsigned char)BuffR[1],
         (unsigned char)BuffR[2],
         (unsigned char)BuffR[3]);



  // uzaven knihovny (TPCI1054U_Done) --------------------------------------------

  result = TPCI1054U_Done(&HNDL);

  // vyhodnocen chyby voln funkce TPCI1054U_Done
  if (result!=0)
  {
    TPCI1054U_Error(result, ErrText);
    printf("Result TPCI1054U_Done: %lu - %s\n", (unsigned long) result, PrevodTextError(ErrText));
    return 0;
  }



  // uvolnn knihovny z pamti --------------------------------------------------

  fFreeResult = FreeLibrary(hinstLib);
  printf("Result Free: %u\n", (unsigned int)fFreeResult);



  return 0;
}

//______________________________________________________________ PrevodAIBusDWord

// Funkce pro pevod pijat zprvy na selnou hodnotu. Vstupem je pijat
// datov st odpovdi modulu MicroUnit, vstupem je spotan DWord hodnota.

uint32_t PrevodAIBusDWord(uint32_t D1, uint32_t D2, uint32_t D3, uint32_t D4)
{
  uint32_t R;

  R = D4;
  R = R*256 + D3;
  R = R*256 + D2;
  R = R*256 + D1;

  return R;
}

//______________________________________________________________ PrevodAIBusDouble

// Funkce pro pevod pijat zprvy na hodnotu real. Vstupem je pijat
// datov st odpovdi modulu MicroUnit, vstupem je spotan real hodnota.

double PrevodAIBusReal(uint32_t D1, uint32_t D2, uint32_t D3, uint32_t D4)
{
  uint8_t i,Exp;
  double R;

  R=(D3&0x7F)*1.0;
  R=(R*256.0+D2)*256.0+D1;
  if(D3>127) R=-R;
  Exp=D4&0x7F;
  if(Exp>0)
  {
    for(i=0;i<Exp;i++)
    {
      R=R/10.0;
    }
  }
  return R;
}


//________________________________________________________ PrevodTextError

// Funkce pro pevod pole typu Buff na string. Vstupem je text ve form pole,
// vstupem je text ve form stringu.

uint8_t* PrevodTextError(uint32_t *B)
{
  static uint8_t s[128];
  uint32_t i;

  for(i=0; (B[i]!=0) && (i<100); i++)
  {
    s[i] = (uint8_t)B[i];
  }

  return s;
}

//______________________________________________________________________________
